#!/usr/bin/env node
"use strict";var ue=require("@modelcontextprotocol/sdk/server/index.js"),he=require("@modelcontextprotocol/sdk/server/stdio.js"),f=require("@modelcontextprotocol/sdk/types.js");var y=require("@modelcontextprotocol/sdk/types.js"),T=class{constructor(t){this.ankiClient=t}async listResources(){let t=[],e=await this.ankiClient.getDeckNames();for(let r of e)t.push({uri:`/decks/${encodeURIComponent(r)}`,name:r,type:"deck",description:`Anki deck: ${r}`}),t.push({uri:`/decks/${encodeURIComponent(r)}/notes`,name:`${r} - Note List`,type:"deck_notes",description:`All notes in deck ${r}`}),t.push({uri:`/decks/${encodeURIComponent(r)}/analysis`,name:`${r} - Learning Analysis`,type:"deck_analysis",description:`Learning progress and statistical analysis for deck ${r}`});let n=await this.ankiClient.getModelNames();for(let r of n)t.push({uri:`/noteTypes/${encodeURIComponent(r)}`,name:r,type:"noteType",description:`Anki note type: ${r}`});return t.push({uri:"/search/notes",name:"Note Search",type:"search",description:"Search Anki notes (use query parameter ?query=search_term)"}),t.push({uri:"/search/cards",name:"Card Search",type:"search",description:"Search Anki cards (use query parameter ?query=search_term)"}),t.push({uri:"/server/config",name:"Server Configuration",type:"configuration",description:"Anki MCP server configuration information"}),t.push({uri:"/stats/overview",name:"Learning Overview",type:"statistics",description:"Overall learning progress and statistical data"}),{resources:t}}async listResourceTemplates(){let t=[];return t.push({uri:"/templates/deck",name:"New Deck Template",type:"deck",description:"Template for creating new Anki deck",schema:{type:"object",properties:{name:{type:"string",description:"Deck name"},description:{type:"string",description:"Deck description"}},required:["name"]}}),t.push({uri:"/templates/noteType",name:"New Note Type Template",type:"noteType",description:"Template for creating new Anki note type",schema:{type:"object",properties:{name:{type:"string",description:"Note type name"},fields:{type:"array",items:{type:"string"},description:"List of field names"},css:{type:"string",description:"CSS styling"},templates:{type:"array",items:{type:"object",properties:{name:{type:"string",description:"Template name"},front:{type:"string",description:"Front template"},back:{type:"string",description:"Back template"}},required:["name","front","back"]},description:"Card templates"}},required:["name","fields","templates"]}}),t.push({uri:"/templates/search",name:"Search Query Template",type:"search",description:"Template for Anki search queries",schema:{type:"object",properties:{query:{type:"string",description:"Search query string"},type:{type:"string",enum:["notes","cards"],description:"Search type: notes or cards"},limit:{type:"number",description:"Limit on number of results returned",default:50}},required:["query","type"]}}),{templates:t}}async readResource(t){let[e,n]=t.split("?"),r=new URLSearchParams(n||"");if(e.startsWith("/decks/"))return await this.handleDeckResource(e,r);if(e.startsWith("/noteTypes/"))return await this.handleNoteTypeResource(e);if(e.startsWith("/search/"))return await this.handleSearchResource(e,r);if(e.startsWith("/notes/"))return await this.handleNoteResource(e);if(e.startsWith("/cards/"))return await this.handleCardResource(e);if(e.startsWith("/stats/"))return await this.handleStatsResource(e);if(e==="/server/config")return await this.handleServerConfig();throw new y.McpError(y.ErrorCode.MethodNotFound,`Resource not found: ${t}`)}async handleDeckResource(t,e){let n=t.split("/"),r=decodeURIComponent(n[2]);if(n.length===3){let i=await this.ankiClient.getDeckStats(r);return{content:[{type:"text",text:JSON.stringify({deckName:r,stats:i,description:`Statistics for deck ${r}`},null,2)}]}}if(n[3]==="notes"){let i=await this.ankiClient.findNotes(`deck:"${r}"`),s=parseInt(e.get("limit")||"20"),o=i.slice(0,s);if(o.length>0){let a=await this.ankiClient.notesInfo(o);return{content:[{type:"text",text:JSON.stringify({deckName:r,totalNotes:i.length,displayedNotes:o.length,notes:a.map(c=>({id:c.noteId,type:c.modelName,tags:c.tags,fields:c.fields}))},null,2)}]}}else return{content:[{type:"text",text:JSON.stringify({deckName:r,totalNotes:0,notes:[],message:"No notes found in this deck"},null,2)}]}}if(n[3]==="analysis"){let i=await this.ankiClient.getDeckStats(r),s=await this.ankiClient.findNotes(`deck:"${r}"`),o=await this.ankiClient.findCards(`deck:"${r}"`),a=[];if(o.length>0){let l=o.slice(0,100);a=await this.ankiClient.cardsInfo(l)}let c={deckName:r,overview:{totalNotes:s.length,totalCards:o.length,...i},cardDistribution:this.analyzeCardDistribution(a),learningProgress:this.calculateLearningProgress(a),recommendations:this.generateRecommendations(i,a)};return{content:[{type:"text",text:JSON.stringify(c,null,2)}]}}throw new y.McpError(y.ErrorCode.MethodNotFound,`Invalid deck resource path: ${t}`)}async handleNoteTypeResource(t){let e=decodeURIComponent(t.substring(11)),[n,r,i]=await Promise.all([this.ankiClient.getModelFieldNames(e),this.ankiClient.getModelTemplates(e),this.ankiClient.getModelStyling(e)]),s={modelName:e,fields:n,templates:r,css:i.css,description:`Complete definition of note type ${e}`};return{content:[{type:"text",text:JSON.stringify(s,null,2)}]}}async handleSearchResource(t,e){let n=e.get("query");if(!n)throw new y.McpError(y.ErrorCode.InvalidParams,"Search query parameter 'query' is required");let r=parseInt(e.get("limit")||"50");if(t==="/search/notes"){let i=await this.ankiClient.findNotes(n),s=i.slice(0,r);if(s.length>0){let o=await this.ankiClient.notesInfo(s);return{content:[{type:"text",text:JSON.stringify({query:n,totalFound:i.length,displayed:s.length,notes:o.map(a=>({id:a.noteId,type:a.modelName,tags:a.tags,fields:a.fields}))},null,2)}]}}else return{content:[{type:"text",text:JSON.stringify({query:n,totalFound:0,notes:[],message:"No matching notes found"},null,2)}]}}if(t==="/search/cards"){let i=await this.ankiClient.findCards(n),s=i.slice(0,r);if(s.length>0){let o=await this.ankiClient.cardsInfo(s);return{content:[{type:"text",text:JSON.stringify({query:n,totalFound:i.length,displayed:s.length,cards:o.map(a=>({id:a.cardId,noteId:a.noteId,deckName:a.deckName,question:a.question,answer:a.answer,type:a.type,queue:a.queue,due:a.due,interval:a.interval,factor:a.factor,reviews:a.reps,lapses:a.lapses}))},null,2)}]}}else return{content:[{type:"text",text:JSON.stringify({query:n,totalFound:0,cards:[],message:"No matching cards found"},null,2)}]}}throw new y.McpError(y.ErrorCode.MethodNotFound,`Invalid search resource path: ${t}`)}async handleNoteResource(t){let e=parseInt(t.substring(7));if(isNaN(e))throw new y.McpError(y.ErrorCode.InvalidParams,"Invalid note ID");let n=await this.ankiClient.notesInfo([e]);if(n.length===0)throw new y.McpError(y.ErrorCode.MethodNotFound,`Note not found: ${e}`);let r=n[0];return{content:[{type:"text",text:JSON.stringify({id:r.noteId,type:r.modelName,tags:r.tags,fields:r.fields,description:`Detailed information for note ${e}`},null,2)}]}}async handleCardResource(t){let e=parseInt(t.substring(7));if(isNaN(e))throw new y.McpError(y.ErrorCode.InvalidParams,"Invalid card ID");let n=await this.ankiClient.cardsInfo([e]);if(n.length===0)throw new y.McpError(y.ErrorCode.MethodNotFound,`Card not found: ${e}`);let r=n[0];return{content:[{type:"text",text:JSON.stringify({id:r.cardId,noteId:r.noteId,deckName:r.deckName,question:r.question,answer:r.answer,type:r.type,queue:r.queue,due:r.due,interval:r.interval,factor:r.factor,reviews:r.reps,lapses:r.lapses,description:`Detailed information for card ${e}`},null,2)}]}}async handleStatsResource(t){if(t==="/stats/overview"){let e=await this.ankiClient.getDeckNames(),n={totalDecks:e.length,deckStats:{},summary:{description:"Anki learning data overview"}};for(let r of e.slice(0,10))try{n.deckStats[r]=await this.ankiClient.getDeckStats(r)}catch{n.deckStats[r]={error:"Unable to retrieve statistics data"}}return{content:[{type:"text",text:JSON.stringify(n,null,2)}]}}throw new y.McpError(y.ErrorCode.MethodNotFound,`Invalid statistics resource path: ${t}`)}async handleServerConfig(){return{content:[{type:"text",text:JSON.stringify({ankiConnectUrl:"http://localhost:8765",apiVersion:6,features:{resources:!0,tools:!0,prompts:!0,sampling:!1},version:"0.1.5+",description:"Anki MCP server configuration information",capabilities:{resources:"Supports multiple resource types including decks, notes, search, statistics, etc.",tools:"Provides complete Anki operation toolkit",prompts:"Provides 8 professional learning assistant prompt templates"}},null,2)}]}}analyzeCardDistribution(t){let e={byType:{},byQueue:{},total:t.length};return t.forEach(n=>{let r=n.type||"unknown";e.byType[r]=(e.byType[r]||0)+1;let i=n.queue||"unknown";e.byQueue[i]=(e.byQueue[i]||0)+1}),e}calculateLearningProgress(t){let e={mature:0,young:0,learning:0,relearning:0,suspended:0,buried:0};return t.forEach(n=>{let r=n.interval||0,i=n.queue||0;i===-1?e.suspended++:i===-2||i===-3?e.buried++:i===1||i===3?e.learning++:i===2&&(r>=21?e.mature++:e.young++)}),e}generateRecommendations(t,e){let n=[];t.new_count&&t.new_count>50&&n.push("Recommend controlling new card quantity appropriately, focus on reviewing learned content"),t.learn_count&&t.learn_count>100&&n.push("Many cards are in learning phase, suggest prioritizing completion of these cards");let r=this.calculateLearningProgress(e),i=r.mature+r.young+r.learning+r.relearning;return i>0&&(r.mature/i<.3&&n.push("Low proportion of mature cards, recommend persistent review to consolidate memory"),r.suspended>i*.1&&n.push("Many suspended cards, consider reactivating some important content")),n.length>0?n:["Keep up the good learning habits!"]}};var E=require("@modelcontextprotocol/sdk/types.js");var pe=require("yanki-connect"),v=require("@modelcontextprotocol/sdk/types.js");var se=class{constructor(){this.cache=new Map;this.defaultTTL=5*60*1e3}get(t){let e=this.cache.get(t);return e?Date.now()-e.timestamp>e.ttl?(this.cache.delete(t),null):e.data:null}set(t,e,n=this.defaultTTL){this.cache.set(t,{data:e,timestamp:Date.now(),ttl:n})}delete(t){return this.cache.delete(t)}deleteByPrefix(t){for(let e of this.cache.keys())e.startsWith(t)&&this.cache.delete(e)}cleanup(){let t=Date.now();for(let[e,n]of this.cache.entries())t-n.timestamp>n.ttl&&this.cache.delete(e)}getStats(){let t=Date.now(),e=0;for(let n of this.cache.values())t-n.timestamp>n.ttl&&e++;return{totalEntries:this.cache.size,expiredEntries:e,memoryUsage:`${(JSON.stringify([...this.cache.values()]).length/1024).toFixed(2)} KB`}}clear(){this.cache.clear()}},oe=class{constructor(){this.operations=new Map}startOperation(t){let e=Date.now();return()=>{let r=Date.now()-e;this.recordOperation(t,r)}}recordOperation(t,e){let n=this.operations.get(t);n?(n.count++,n.totalTime+=e,n.avgTime=n.totalTime/n.count,n.maxTime=Math.max(n.maxTime,e),n.minTime=Math.min(n.minTime,e),n.lastRun=Date.now()):this.operations.set(t,{count:1,totalTime:e,avgTime:e,maxTime:e,minTime:e,lastRun:Date.now()})}getStats(t){if(t)return this.operations.get(t)||null;let e=Object.fromEntries(this.operations.entries()),n=Object.entries(e).sort(([,r],[,i])=>i.avgTime-r.avgTime);return{operations:e,slowestOperations:n.slice(0,5),totalOperations:Array.from(this.operations.values()).reduce((r,i)=>r+i.count,0)}}getOptimizationSuggestions(){let t=[],e=Array.from(this.operations.entries()),n=e.filter(([,s])=>s.avgTime>1e3);n.length>0&&t.push(`Found ${n.length} slow operations with average time > 1s, recommend optimization`);let r=e.filter(([,s])=>s.count>50);r.length>0&&t.push(`Found ${r.length} high-frequency operations, consider cache optimization`);let i=e.filter(([,s])=>s.maxTime>s.avgTime*3&&s.count>5);return i.length>0&&t.push(`Found ${i.length} operations with unstable performance, recommend checking implementation`),t.length>0?t:["Performance is good, no special optimization needed"]}reset(){this.operations.clear()}},ae=class{constructor(){this.batchSize=50;this.maxConcurrency=3}async processBatch(t,e,n){let{batchSize:r=this.batchSize,maxConcurrency:i=this.maxConcurrency,onProgress:s}=n||{},o=[];for(let h=0;h<t.length;h+=r)o.push(t.slice(h,h+r));let a=[],c=0,l=async h=>{for(;h.length>0;){let k=h.shift();if(!k)break;try{let b=await e(k);a.push(...b),c+=k.length,s&&s(c,t.length)}catch(b){console.error("Batch processing error:",b)}}},u=Array.from({length:Math.min(i,o.length)},()=>l([...o]));return await Promise.all(u),a}async adaptiveBatch(t,e,n=500){let r=this.batchSize,i=[];for(let s=0;s<t.length;s+=r){let o=t.slice(s,s+r),a=Date.now();try{let c=await e(o);i.push(...c);let l=Date.now()-a;l<n/2&&r<100?r=Math.min(r*1.5,100):l>n&&r>10&&(r=Math.max(r*.8,10))}catch(c){console.error("Adaptive batch processing error:",c),r=Math.max(r/2,1),s-=r}}return i}},I=new se,de=new oe,Ce=new ae;var N=class extends Error{constructor(t){super(t),this.name="AnkiConnectionError"}},P=class extends Error{constructor(t){super(t),this.name="AnkiTimeoutError"}},R=class extends Error{constructor(e,n){super(e);this.code=n;this.name="AnkiApiError"}},ge={ankiConnectUrl:"http://localhost:8765",apiVersion:6,timeout:5e3,retryTimeout:1e4,defaultDeck:"Default",enableCache:!0,enablePerformanceMonitoring:!0},S=class{constructor(t={}){this.config={...ge,...t},this.client=new pe.YankiConnect,this.config.enableCache&&setInterval(()=>{I.cleanup()},5*60*1e3)}async executeWithRetry(t,e="unknown",n=1){let r=null;this.config.enablePerformanceMonitoring&&(r=de.startOperation(e));let i=null;try{for(let s=0;s<=n;s++)try{return await t()}catch(o){if(i=this.normalizeError(o),s<n){let a=Math.min(1e3*Math.pow(2,s),this.config.retryTimeout);await new Promise(c=>setTimeout(c,a))}}throw i||new N("Unknown error occurred")}finally{r&&r()}}async executeWithCache(t,e,n,r=5*60*1e3){if(this.config.enableCache){let s=I.get(t);if(s!==null)return s}let i=await this.executeWithRetry(e,n);return this.config.enableCache&&I.set(t,i,r),i}normalizeError(t){return t instanceof Error?t.message.includes("ECONNREFUSED")?new N("Anki is not running. Please start Anki and ensure AnkiConnect plugin is enabled."):t.message.includes("timeout")||t.message.includes("ETIMEDOUT")?new P("Connection to Anki timed out. Please check if Anki is responsive."):t.message.includes("collection unavailable")?new R("Anki collection is unavailable. Please close any open dialogs in Anki."):t:new Error(String(t))}wrapError(t){return t instanceof N?new v.McpError(v.ErrorCode.InternalError,t.message):t instanceof P?new v.McpError(v.ErrorCode.InternalError,t.message):t instanceof R?new v.McpError(v.ErrorCode.InternalError,t.message):new v.McpError(v.ErrorCode.InternalError,`Anki error: ${t.message}`)}async checkConnection(){try{return await this.executeWithRetry(()=>this.client.invoke("version"),"checkConnection"),!0}catch(t){throw this.wrapError(t instanceof Error?t:new Error(String(t)))}}async getDeckNames(){try{return await this.executeWithCache("deckNames",()=>this.client.deck.deckNames(),"getDeckNames",2*60*1e3)}catch(t){throw this.wrapError(t instanceof Error?t:new Error(String(t)))}}async createDeck(t){try{let e=await this.executeWithRetry(()=>this.client.deck.createDeck({deck:t}),"createDeck");return this.config.enableCache&&I.deleteByPrefix("deck"),typeof e=="number"?e:0}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async deleteDeck(t){try{await this.executeWithRetry(()=>this.client.deck.deleteDecks({decks:[t],cardsToo:!0}),"deleteDeck"),this.config.enableCache&&(I.deleteByPrefix("deck"),I.delete(`deckStats:${t}`))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async getDeckStats(t){try{return await this.executeWithCache(`deckStats:${t}`,()=>this.client.deck.getDeckStats({decks:[t]}),"getDeckStats",1*60*1e3)}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async getModelNames(){try{return await this.executeWithCache("modelNames",()=>this.client.model.modelNames(),"getModelNames",5*60*1e3)}catch(t){throw this.wrapError(t instanceof Error?t:new Error(String(t)))}}async getModelFieldNames(t){try{return await this.executeWithCache(`modelFields:${t}`,()=>this.client.model.modelFieldNames({modelName:t}),"getModelFieldNames",10*60*1e3)}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async getModelTemplates(t){try{return await this.executeWithCache(`modelTemplates:${t}`,()=>this.client.model.modelTemplates({modelName:t}),"getModelTemplates",10*60*1e3)}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async getModelStyling(t){try{return await this.executeWithCache(`modelStyling:${t}`,()=>this.client.model.modelStyling({modelName:t}),"getModelStyling",10*60*1e3)}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async addNote(t){try{return await this.executeWithRetry(()=>{var e;return this.client.note.addNote({note:{deckName:t.deckName,modelName:t.modelName,fields:t.fields,tags:t.tags||[],options:{allowDuplicate:((e=t.options)==null?void 0:e.allowDuplicate)||!1,duplicateScope:"deck"}}})})}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async addNotes(t){try{return await this.executeWithRetry(()=>this.client.note.addNotes({notes:t.map(e=>({deckName:e.deckName,modelName:e.modelName,fields:e.fields,tags:e.tags||[],options:{allowDuplicate:!1,duplicateScope:"deck"}}))}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async findNotes(t){try{let e=await this.executeWithRetry(()=>this.client.note.findNotes({query:t}));return Array.isArray(e)?e.filter(n=>typeof n=="number"):[]}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async findCards(t){try{let e=await this.executeWithRetry(()=>this.client.card.findCards({query:t}));return Array.isArray(e)?e.filter(n=>typeof n=="number"):[]}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async cardsInfo(t){try{let e=await this.executeWithRetry(()=>this.client.card.cardsInfo({cards:t}));return Array.isArray(e)?e:[]}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async suspendCards(t){try{await this.executeWithRetry(()=>this.client.card.suspend({cards:t}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async unsuspendCards(t){try{await this.executeWithRetry(()=>this.client.card.unsuspend({cards:t}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async forgetCards(t){try{await this.executeWithRetry(()=>this.client.card.forgetCards({cards:t}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async relearnCards(t){try{await this.executeWithRetry(()=>this.client.card.relearnCards({cards:t}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async notesInfo(t){try{let e=await this.executeWithRetry(()=>this.client.note.notesInfo({notes:t}));return Array.isArray(e)?e:[]}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async updateNoteFields(t){try{await this.executeWithRetry(()=>this.client.note.updateNoteFields({note:{id:t.id,fields:t.fields}}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async deleteNotes(t){try{await this.executeWithRetry(()=>this.client.note.deleteNotes({notes:t}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async createModel(t){try{let e=t.cardTemplates.map(n=>({name:n.name,Front:n.front,Back:n.back}));await this.executeWithRetry(()=>this.client.model.createModel({modelName:t.modelName,inOrderFields:t.inOrderFields,css:t.css,cardTemplates:e}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}async updateModelTemplates(t){try{let e=t.cardTemplates.map(n=>({Name:n.name,Front:n.front,Back:n.back}));await this.executeWithRetry(()=>this.client.model.updateModelTemplates({model:{name:t.modelName,templates:e}}))}catch(e){throw this.wrapError(e instanceof Error?e:new Error(String(e)))}}};var x=require("@modelcontextprotocol/sdk/types.js");var p=class{constructor(t){this.ankiClient=t}formatSuccessResponse(t){return{content:[{type:"text",text:JSON.stringify(t,null,2)}]}}formatErrorResponse(t){return{content:[{type:"text",text:`Error: ${t instanceof Error?t.message:String(t)}`}],isError:!0}}handleError(t){return console.error(`Tool execution error [${this.constructor.name}]:`,t),this.formatErrorResponse(t)}validateRequiredArgs(t,e){for(let n of e)if(t[n]===void 0||t[n]===null||t[n]==="")throw new Error(`Missing required parameter: ${n}`)}getStringArg(t,e,n=""){let r=t[e];return typeof r=="string"?r:n}getNumberArg(t,e,n=0){let r=t[e];return typeof r=="number"?r:n}getBooleanArg(t,e,n=!1){let r=t[e];return typeof r=="boolean"?r:n}getArrayArg(t,e,n=[]){let r=t[e];return Array.isArray(r)?r:n}limitArrayLength(t,e=100){return t.length>e?(console.warn(`Array length ${t.length} exceeds limit ${e}, trimming`),t.slice(0,e)):t}formatTimestamp(t){return new Date(t*1e3).toLocaleString("en-US")}stripHtml(t){return t.replace(/<[^>]*>/g,"").trim()}truncateText(t,e=200){return t.length<=e?t:t.substring(0,e)+"..."}};var q=class extends p{constructor(e){super(e);this.name="list_decks";this.description="List all available Anki decks";this.inputSchema={type:"object",properties:{},required:[]}}async execute(e){try{let n=await this.ankiClient.getDeckNames();return this.formatSuccessResponse({decks:n,count:n.length})}catch(n){return this.handleError(n)}}},M=class extends p{constructor(e){super(e);this.name="create_deck";this.description="Create a new Anki deck";this.inputSchema={type:"object",properties:{name:{type:"string",description:"Name of the deck to create"}},required:["name"]}}async execute(e){try{if(!e.name)throw new x.McpError(x.ErrorCode.InvalidParams,"Deck name is required");let n=await this.ankiClient.createDeck(e.name);return this.formatSuccessResponse({deckId:n,name:e.name})}catch(n){return this.handleError(n)}}},A=class extends p{constructor(e){super(e);this.name="delete_deck";this.description="Delete an Anki deck";this.inputSchema={type:"object",properties:{name:{type:"string",description:"Name of the deck to delete"}},required:["name"]}}async execute(e){try{if(!e.name)throw new x.McpError(x.ErrorCode.InvalidParams,"Deck name is required");return await this.ankiClient.deleteDeck(e.name),this.formatSuccessResponse({success:!0,name:e.name})}catch(n){return this.handleError(n)}}},D=class extends p{constructor(e){super(e);this.name="get_deck_stats";this.description="Get statistics for a given deck";this.inputSchema={type:"object",properties:{name:{type:"string",description:"Name of the deck to get stats for"}},required:["name"]}}async execute(e){try{if(!e.name)throw new x.McpError(x.ErrorCode.InvalidParams,"Deck name is required");let n=await this.ankiClient.getDeckStats(e.name);return this.formatSuccessResponse(n)}catch(n){return this.handleError(n)}}};var g=require("@modelcontextprotocol/sdk/types.js");var $=class extends p{constructor(e){super(e);this.name="list_note_types";this.description="List all available note types";this.inputSchema={type:"object",properties:{},required:[]}}async execute(e){try{let n=await this.ankiClient.getModelNames();return this.formatSuccessResponse({noteTypes:n,count:n.length})}catch(n){return this.handleError(n)}}},z=class extends p{constructor(e){super(e);this.name="create_note_type";this.description="Create a new note type";this.inputSchema={type:"object",properties:{name:{type:"string",description:"Name of the new note type"},fields:{type:"array",items:{type:"string"},description:"Field names for the note type"},css:{type:"string",description:"CSS styling for the note type"},templates:{type:"array",items:{type:"object",properties:{name:{type:"string"},front:{type:"string"},back:{type:"string"}},required:["name","front","back"]},description:"Card templates"}},required:["name","fields","templates"]}}async execute(e){try{if(!e.name)throw new g.McpError(g.ErrorCode.InvalidParams,"Note type name is required");if(!e.fields||e.fields.length===0)throw new g.McpError(g.ErrorCode.InvalidParams,"Fields are required");if(!e.templates||e.templates.length===0)throw new g.McpError(g.ErrorCode.InvalidParams,"Templates are required");if((await this.ankiClient.getModelNames()).includes(e.name))throw new g.McpError(g.ErrorCode.InvalidParams,`Note type already exists: ${e.name}`);return await this.ankiClient.createModel({modelName:e.name,inOrderFields:e.fields,css:e.css||"",cardTemplates:e.templates}),this.formatSuccessResponse({success:!0,modelName:e.name,fields:e.fields,templates:e.templates.length})}catch(n){return this.handleError(n)}}},O=class extends p{constructor(e){super(e);this.name="update_note_type_templates";this.description="Update the templates of a note type";this.inputSchema={type:"object",properties:{name:{type:"string",description:"Name of the note type to update"},templates:{type:"array",items:{type:"object",properties:{name:{type:"string"},front:{type:"string"},back:{type:"string"}},required:["name","front","back"]},description:"New card templates"}},required:["name","templates"]}}async execute(e){try{if(!e.name)throw new g.McpError(g.ErrorCode.InvalidParams,"Note type name is required");if(!e.templates||e.templates.length===0)throw new g.McpError(g.ErrorCode.InvalidParams,"Templates are required");return await this.ankiClient.updateModelTemplates({modelName:e.name,cardTemplates:e.templates}),this.formatSuccessResponse({success:!0,modelName:e.name})}catch(n){return this.handleError(n)}}},F=class extends p{constructor(e){super(e);this.name="get_note_type_info";this.description="Get detailed structure of a note type";this.inputSchema={type:"object",properties:{modelName:{type:"string",description:"Name of the note type/model"},includeCss:{type:"boolean",description:"Whether to include CSS information"}},required:["modelName"]}}async execute(e){try{if(!e.modelName)throw new g.McpError(g.ErrorCode.InvalidParams,"Model name is required");if(!(await this.ankiClient.getModelNames()).includes(e.modelName))throw new g.McpError(g.ErrorCode.InvalidParams,`Note type not found: ${e.modelName}`);let[r,i]=await Promise.all([this.ankiClient.getModelFieldNames(e.modelName),this.ankiClient.getModelTemplates(e.modelName)]),s={modelName:e.modelName,fields:r,templates:i};if(e.includeCss){let o=await this.ankiClient.getModelStyling(e.modelName);s.css=o.css}return this.formatSuccessResponse(s)}catch(n){return this.handleError(n)}}};var m=require("@modelcontextprotocol/sdk/types.js");var j=class extends p{constructor(e){super(e);this.name="create_note";this.description="Create a new note (LLM Should call get_note_type_info first)";this.inputSchema={type:"object",properties:{type:{type:"string",description:"Note type"},deck:{type:"string",description:"Deck name"},fields:{type:"object",description:"Custom fields for the note(get note type info first)",additionalProperties:!0},allowDuplicate:{type:"boolean",description:"Whether to allow duplicate notes"},tags:{type:"array",items:{type:"string"},description:"Tags for the note"}},required:["type","deck","fields"]}}async execute(e){try{if(!e.type)throw new m.McpError(m.ErrorCode.InvalidParams,"Note type is required");if(!e.deck)throw new m.McpError(m.ErrorCode.InvalidParams,"Deck name is required");if(!e.fields||Object.keys(e.fields).length===0)throw new m.McpError(m.ErrorCode.InvalidParams,"Fields are required");if((await this.ankiClient.getDeckNames()).includes(e.deck)||await this.ankiClient.createDeck(e.deck),!(await this.ankiClient.getModelNames()).includes(e.type))throw new m.McpError(m.ErrorCode.InvalidParams,`Note type not found: ${e.type}`);let i=await this.ankiClient.getModelFieldNames(e.type),s={};for(let a of i)s[a]=e.fields[a]||e.fields[a.toLowerCase()]||"";let o=await this.ankiClient.addNote({deckName:e.deck,modelName:e.type,fields:s,tags:e.tags||[],options:{allowDuplicate:e.allowDuplicate||!1}});return this.formatSuccessResponse({noteId:o,deck:e.deck,modelName:e.type})}catch(n){return this.handleError(n)}}},L=class extends p{constructor(e){super(e);this.name="batch_create_notes";this.description="Create multiple notes at once (llm should call get_note_type_info first )";this.inputSchema={type:"object",properties:{notes:{type:"array",items:{type:"object",properties:{type:{type:"string",enum:["Basic","Cloze"]},deck:{type:"string"},fields:{type:"object",additionalProperties:!0},tags:{type:"array",items:{type:"string"}}},required:["type","deck","fields"]}},allowDuplicate:{type:"boolean",description:"Whether to allow duplicate notes"},stopOnError:{type:"boolean",description:"Whether to stop on first error"}},required:["notes"]}}async execute(e){try{if(!e.notes||!Array.isArray(e.notes)||e.notes.length===0)throw new m.McpError(m.ErrorCode.InvalidParams,"Notes array is required");let n=[],r=e.stopOnError!==!1;for(let i=0;i<e.notes.length;i++){let s=e.notes[i];try{if((await this.ankiClient.getDeckNames()).includes(s.deck)||await this.ankiClient.createDeck(s.deck),!(await this.ankiClient.getModelNames()).includes(s.type))throw new Error(`Note type not found: ${s.type}`);let c=await this.ankiClient.getModelFieldNames(s.type),l={};for(let h of c)l[h]=s.fields[h]||s.fields[h.toLowerCase()]||"";let u=await this.ankiClient.addNote({deckName:s.deck,modelName:s.type,fields:l,tags:s.tags||[],options:{allowDuplicate:e.allowDuplicate||!1}});n.push({success:!0,noteId:u,index:i})}catch(o){if(n.push({success:!1,error:o instanceof Error?o.message:String(o),index:i}),r)break}}return this.formatSuccessResponse({results:n,total:e.notes.length,successful:n.filter(i=>i.success).length,failed:n.filter(i=>!i.success).length})}catch(n){return this.handleError(n)}}},W=class extends p{constructor(e){super(e);this.name="search_notes";this.description="Search for notes using Anki query syntax";this.inputSchema={type:"object",properties:{query:{type:"string",description:"Anki search query"}},required:["query"]}}async execute(e){try{if(!e.query)throw new m.McpError(m.ErrorCode.InvalidParams,"Search query is required");let n=await this.ankiClient.findNotes(e.query),r=[];if(n.length>0){let i=Math.min(n.length,50);r=await this.ankiClient.notesInfo(n.slice(0,i))}return this.formatSuccessResponse({query:e.query,total:n.length,notes:r,limitApplied:n.length>50})}catch(n){return this.handleError(n)}}},H=class extends p{constructor(e){super(e);this.name="get_note_info";this.description="Get detailed information about a note";this.inputSchema={type:"object",properties:{noteId:{type:"number",description:"Note ID"}},required:["noteId"]}}async execute(e){try{if(!e.noteId)throw new m.McpError(m.ErrorCode.InvalidParams,"Note ID is required");let n=await this.ankiClient.notesInfo([e.noteId]);if(!n||n.length===0)throw new m.McpError(m.ErrorCode.InvalidParams,`Note not found: ${e.noteId}`);return this.formatSuccessResponse(n[0])}catch(n){return this.handleError(n)}}},U=class extends p{constructor(e){super(e);this.name="update_note";this.description="Update an existing note";this.inputSchema={type:"object",properties:{id:{type:"number",description:"Note ID"},fields:{type:"object",description:"Fields to update"},tags:{type:"array",items:{type:"string"},description:"New tags for the note"}},required:["id","fields"]}}async execute(e){try{if(!e.id)throw new m.McpError(m.ErrorCode.InvalidParams,"Note ID is required");if(!e.fields||Object.keys(e.fields).length===0)throw new m.McpError(m.ErrorCode.InvalidParams,"Fields are required");let n=await this.ankiClient.notesInfo([e.id]);if(!n||n.length===0)throw new m.McpError(m.ErrorCode.InvalidParams,`Note not found: ${e.id}`);return await this.ankiClient.updateNoteFields({id:e.id,fields:e.fields}),this.formatSuccessResponse({success:!0,noteId:e.id})}catch(n){return this.handleError(n)}}},B=class extends p{constructor(e){super(e);this.name="delete_note";this.description="Delete a note";this.inputSchema={type:"object",properties:{noteId:{type:"number",description:"Note ID to delete"}},required:["noteId"]}}async execute(e){try{if(!e.noteId)throw new m.McpError(m.ErrorCode.InvalidParams,"Note ID is required");return await this.ankiClient.deleteNotes([e.noteId]),this.formatSuccessResponse({success:!0,noteId:e.noteId})}catch(n){return this.handleError(n)}}},_=class extends p{constructor(t,e){super(t),this.name=`create_${e.toLowerCase().replace(/ /g,"_")}_note`,this.description=`Create a new note of type ${e}`,this.inputSchema={type:"object",properties:{deck:{type:"string",description:"Deck name"}},required:["deck"],additionalProperties:!0}}async execute(t){try{let e=this.name.replace(/^create_/,"").replace(/_note$/,"").replace(/_/g," ");if(!t.deck)throw new m.McpError(m.ErrorCode.InvalidParams,"Deck name is required");if(!(await this.ankiClient.getModelNames()).includes(e))throw new m.McpError(m.ErrorCode.InvalidParams,`Note type not found: ${e}`);(await this.ankiClient.getDeckNames()).includes(t.deck)||await this.ankiClient.createDeck(t.deck);let i=await this.ankiClient.getModelFieldNames(e),s={};for(let c of i)s[c]=t[c.toLowerCase()]||t[c]||"";let o=Array.isArray(t.tags)?t.tags:[],a=await this.ankiClient.addNote({deckName:t.deck,modelName:e,fields:s,tags:o});return this.formatSuccessResponse({noteId:a,deck:t.deck,modelName:e})}catch(e){return this.handleError(e)}}};var w=require("@modelcontextprotocol/sdk/types.js");var J=class extends p{constructor(e){super(e);this.name="list_cards";this.description="List cards based on a query";this.inputSchema={type:"object",properties:{query:{type:"string",description:"Anki search query for cards"}},required:["query"]}}async execute(e){try{if(!e.query)throw new w.McpError(w.ErrorCode.InvalidParams,"Search query is required");let n=await this.ankiClient.findCards(e.query);return this.formatSuccessResponse({query:e.query,total:n.length,cardIds:n})}catch(n){return this.handleError(n)}}},G=class extends p{constructor(e){super(e);this.name="get_card_info";this.description="Get detailed information about a card";this.inputSchema={type:"object",properties:{cardId:{type:"number",description:"ID of the card to get info for"}},required:["cardId"]}}async execute(e){try{if(!e.cardId)throw new w.McpError(w.ErrorCode.InvalidParams,"Card ID is required");let n=await this.ankiClient.cardsInfo([e.cardId]);if(!n||n.length===0)throw new w.McpError(w.ErrorCode.InvalidParams,`Card not found: ${e.cardId}`);return this.formatSuccessResponse(n[0])}catch(n){return this.handleError(n)}}},K=class extends p{constructor(e){super(e);this.name="suspend_cards";this.description="Suspend cards";this.inputSchema={type:"object",properties:{cardIds:{type:"array",items:{type:"number"},description:"Array of card IDs to suspend"}},required:["cardIds"]}}async execute(e){try{if(!e.cardIds||e.cardIds.length===0)throw new w.McpError(w.ErrorCode.InvalidParams,"Card IDs are required");return await this.ankiClient.suspendCards(e.cardIds),this.formatSuccessResponse({success:!0,cardIds:e.cardIds})}catch(n){return this.handleError(n)}}},V=class extends p{constructor(e){super(e);this.name="unsuspend_cards";this.description="Unsuspend cards";this.inputSchema={type:"object",properties:{cardIds:{type:"array",items:{type:"number"},description:"Array of card IDs to unsuspend"}},required:["cardIds"]}}async execute(e){try{if(!e.cardIds||e.cardIds.length===0)throw new w.McpError(w.ErrorCode.InvalidParams,"Card IDs are required");return await this.ankiClient.unsuspendCards(e.cardIds),this.formatSuccessResponse({success:!0,cardIds:e.cardIds})}catch(n){return this.handleError(n)}}},Q=class extends p{constructor(e){super(e);this.name="forget_cards";this.description="Forget cards, resetting their progress";this.inputSchema={type:"object",properties:{cardIds:{type:"array",items:{type:"number"},description:"Array of card IDs to forget"}},required:["cardIds"]}}async execute(e){try{if(!e.cardIds||e.cardIds.length===0)throw new w.McpError(w.ErrorCode.InvalidParams,"Card IDs are required");return await this.ankiClient.forgetCards(e.cardIds),this.formatSuccessResponse({success:!0,cardIds:e.cardIds})}catch(n){return this.handleError(n)}}},Y=class extends p{constructor(e){super(e);this.name="relearn_cards";this.description="Relearn cards, moving them to the relearn queue";this.inputSchema={type:"object",properties:{cardIds:{type:"array",items:{type:"number"},description:"Array of card IDs to relearn"}},required:["cardIds"]}}async execute(e){try{if(!e.cardIds||e.cardIds.length===0)throw new w.McpError(w.ErrorCode.InvalidParams,"Card IDs are required");return await this.ankiClient.relearnCards(e.cardIds),this.formatSuccessResponse({success:!0,cardIds:e.cardIds})}catch(n){return this.handleError(n)}}};var ee=require("@modelcontextprotocol/sdk/types.js"),X=class extends p{constructor(){super(...arguments);this.name="analyze_learning_progress";this.description="Analyze learning progress and performance, provide personalized recommendations";this.inputSchema={type:"object",properties:{deck_name:{type:"string",description:"Name of the deck to analyze (optional, analyzes all if not specified)"},time_period:{type:"string",enum:["today","week","month","all"],description:"Analysis time period",default:"week"},include_recommendations:{type:"boolean",description:"Whether to include learning recommendations",default:!0}}}}async execute(e){try{let{deck_name:n,time_period:r="week",include_recommendations:i=!0}=e,s=n?[n]:await this.ankiClient.getDeckNames(),o=[];for(let c of s.slice(0,5))try{let l=await this.ankiClient.getDeckStats(c),u=await this.ankiClient.findNotes(`deck:"${c}"`),h=await this.ankiClient.findCards(`deck:"${c}"`),k=[];if(h.length>0){let ye=h.slice(0,50);k=await this.ankiClient.cardsInfo(ye)}let b=this.calculateLearningMetrics(l,k),ce=this.analyzeTrends(k,r),le=this.identifyDifficulties(k);o.push({deckName:c,totalNotes:u.length,totalCards:h.length,metrics:b,trends:ce,difficulties:le,...i&&{recommendations:this.generateRecommendations(b,ce,le)}})}catch(l){o.push({deckName:c,error:`Analysis failed: ${l instanceof Error?l.message:String(l)}`})}let a={summary:{total_decks_analyzed:o.filter(c=>!c.error).length,analysis_period:r,generated_at:new Date().toISOString()},deck_analyses:o,overall_recommendations:this.generateOverallRecommendations(o)};return this.formatSuccessResponse(a)}catch(n){return this.handleError(n)}}calculateLearningMetrics(e,n){let r=n.length;if(r===0)return{total:0};let i={new:0,learning:0,review:0,suspended:0},s={mature:0,young:0,learning:0},o=0,a=0;return n.forEach(c=>{let l=c.queue||0,u=c.interval||0;l===0?i.new++:l===1||l===3?i.learning++:l===2?i.review++:l===-1&&i.suspended++,u>=21?s.mature++:u>0?s.young++:s.learning++,o+=c.reps||0,a+=c.lapses||0}),{total:r,distribution:i,maturity:s,retention_rate:o>0?Math.round((1-a/o)*100):0,mature_rate:Math.round(s.mature/r*100),stats:{new_today:e.new_count||0,review_today:e.review_count||0,learning_today:e.learn_count||0}}}analyzeTrends(e,n){let r=Date.now(),i=this.getTimeCutoff(n),s=e.filter(o=>(o.mod?o.mod*1e3:0)>=i);return{period:n,cards_reviewed:s.length,avg_ease:s.length>0?Math.round(s.reduce((o,a)=>o+(a.factor||2500),0)/s.length):0,trend_indicator:this.calculateTrendIndicator(s)}}identifyDifficulties(e){let n={high_lapse_cards:0,low_ease_cards:0,overdue_cards:0,problem_areas:[]};return e.forEach(r=>{let i=r.lapses||0,s=r.factor||2500,o=r.due||0;i>=3&&n.high_lapse_cards++,s<2e3&&n.low_ease_cards++,o<0&&n.overdue_cards++}),n.high_lapse_cards>e.length*.1&&n.problem_areas.push("High forgetting rate, recommend adjusting review intervals"),n.low_ease_cards>e.length*.2&&n.problem_areas.push("Some content difficult to understand, recommend adding supplementary materials"),n}generateRecommendations(e,n,r){let i=[];return e.mature_rate<30&&i.push({type:"learning_strategy",priority:"high",message:"\u6210\u719F\u5361\u7247\u6BD4\u4F8B\u8F83\u4F4E\uFF0C\u5EFA\u8BAE\u575A\u6301\u65E5\u5E38\u590D\u4E60\u4EE5\u63D0\u9AD8\u8BB0\u5FC6\u5DE9\u56FA\u5EA6"}),e.retention_rate<80&&i.push({type:"difficulty_adjustment",priority:"medium",message:"\u8BB0\u5FC6\u4FDD\u6301\u7387\u504F\u4F4E\uFF0C\u8003\u8651\u964D\u4F4E\u5B66\u4E60\u96BE\u5EA6\u6216\u589E\u52A0\u590D\u4E60\u9891\u7387"}),n.cards_reviewed<10&&i.push({type:"consistency",priority:"high",message:"Recent review volume is low, recommend maintaining regular learning rhythm"}),r.problem_areas.forEach(s=>{i.push({type:"problem_solving",priority:"medium",message:s})}),i}generateOverallRecommendations(e){let n=e.filter(o=>!o.error);if(n.length===0)return[];let r=[],i=n.reduce((o,a)=>{var c;return o+(((c=a.metrics)==null?void 0:c.mature_rate)||0)},0)/n.length,s=n.reduce((o,a)=>{var c;return o+(((c=a.recommendations)==null?void 0:c.length)||0)},0);return i<40&&r.push("Overall learning progress is good, but recommend strengthening long-term memory consolidation"),s>n.length*2&&r.push("Multiple areas for improvement found, recommend prioritizing high-priority issues"),r}getTimeCutoff(e){let n=Date.now();switch(e){case"today":return n-24*60*60*1e3;case"week":return n-7*24*60*60*1e3;case"month":return n-30*24*60*60*1e3;default:return 0}}calculateTrendIndicator(e){if(e.length===0)return"insufficient_data";let n=e.reduce((i,s)=>i+(s.factor||2500),0)/e.length,r=e.reduce((i,s)=>i+(s.lapses||0),0)/e.length;return n>2300&&r<1?"improving":n<2e3||r>2?"declining":"stable"}},Z=class extends p{constructor(){super(...arguments);this.name="analyze_knowledge_connections";this.description="Analyze knowledge point correlations and learning paths, optimize learning order";this.inputSchema={type:"object",properties:{deck_name:{type:"string",description:"Name of the deck to analyze",required:!0},connection_type:{type:"string",enum:["tags","content","temporal"],description:"Connection analysis type: tag connections, content connections, temporal connections",default:"tags"},min_connections:{type:"number",description:"Minimum connection count threshold",default:2}},required:["deck_name"]}}async execute(e){try{let{deck_name:n,connection_type:r="tags",min_connections:i=2}=e,s=await this.ankiClient.findNotes(`deck:"${n}"`);if(s.length===0)throw new ee.McpError(ee.ErrorCode.InvalidParams,`No notes found in deck "${n}"`);let o=s.slice(0,100),a=await this.ankiClient.notesInfo(o),c=[],l={};switch(r){case"tags":l=this.analyzeTagConnections(a,i);break;case"content":l=this.analyzeContentConnections(a,i);break;case"temporal":l=this.analyzeTemporalConnections(a,i);break}let u={deck_name:n,analysis_type:r,total_notes:s.length,analyzed_notes:o.length,...l,learning_path_suggestions:this.generateLearningPath(l),optimization_recommendations:this.generateOptimizationRecommendations(l)};return this.formatSuccessResponse(u)}catch(n){return this.handleError(n)}}analyzeTagConnections(e,n){let r=new Map,i=new Map,s=new Map;e.forEach((a,c)=>{let l=a.tags||[];l.forEach(u=>{r.set(u,(r.get(u)||0)+1),s.has(u)||s.set(u,[]),s.get(u).push(c),l.forEach(h=>{if(u!==h){i.has(u)||i.set(u,new Map);let k=i.get(u);k.set(h,(k.get(h)||0)+1)}})})});let o=[];for(let[a,c]of i)for(let[l,u]of c)u>=n&&o.push({from:a,to:l,strength:u,type:"tag_cooccurrence"});return{tag_statistics:Object.fromEntries(r),connections:o,connection_clusters:this.findClusters(o),coverage_analysis:this.analyzeTagCoverage(s,e.length)}}analyzeContentConnections(e,n){let r=new Map;e.forEach((o,a)=>{let c=this.extractTextContent(o.fields);this.extractKeywords(c).forEach(u=>{r.has(u)||r.set(u,new Set),r.get(u).add(a)})});let i=[],s=Array.from(r.entries()).filter(([o,a])=>a.size>=n);for(let o=0;o<s.length;o++)for(let a=o+1;a<s.length;a++){let[c,l]=s[o],[u,h]=s[a],k=new Set([...l].filter(b=>h.has(b)));k.size>=n&&i.push({from:c,to:u,strength:k.size,type:"content_similarity",shared_notes:Array.from(k)})}return{keyword_frequency:Object.fromEntries(s.map(([o,a])=>[o,a.size])),connections:i,content_clusters:this.groupByContentSimilarity(e,r)}}analyzeTemporalConnections(e,n){let r=new Map;e.forEach((s,o)=>{let a=s.mod||0,l=new Date(a*1e3).toISOString().split("T")[0];r.has(l)||r.set(l,[]),r.get(l).push(o)});let i=Array.from(r.entries()).filter(([s,o])=>o.length>=n).map(([s,o])=>({date:s,note_count:o.length,note_indices:o}));return{temporal_patterns:i,learning_sessions:this.identifyLearningSessions(i),study_frequency:this.calculateStudyFrequency(i)}}generateLearningPath(e){let n=[];if(e.tag_statistics){let r=Object.entries(e.tag_statistics).sort(([,i],[,s])=>s-i).slice(0,5);n.push({type:"tag_based_path",recommendation:"Recommend learning by tag frequency",path:r.map(([i])=>i)})}if(e.connections&&e.connections.length>0){let r=e.connections.sort((i,s)=>s.strength-i.strength).slice(0,3);n.push({type:"connection_based_path",recommendation:"Prioritize learning strongly connected knowledge points",connections:r})}return n}generateOptimizationRecommendations(e){let n=[];return e.connection_clusters&&e.connection_clusters.length>3&&n.push({type:"structure",message:"Knowledge points are highly dispersed, recommend creating sub-decks for better categorization"}),e.coverage_analysis&&e.coverage_analysis.untagged_ratio>.3&&n.push({type:"tagging",message:"Many notes lack tags, recommend adding tags to improve knowledge organization"}),n}extractTextContent(e){return Object.values(e||{}).map(n=>n.value||"").join(" ")}extractKeywords(e){return e.toLowerCase().replace(/[^\w\s\u4e00-\u9fff]/g," ").split(/\s+/).filter(n=>n.length>2).slice(0,10)}findClusters(e){let n=[],r=new Set;return e.forEach(i=>{if(!r.has(i.from)&&!r.has(i.to)){let s=[i.from,i.to];r.add(i.from),r.add(i.to),n.push(s)}}),n}analyzeTagCoverage(e,n){let r=new Set;return e.forEach(i=>{i.forEach(s=>r.add(s))}),{tagged_notes:r.size,total_notes:n,coverage_ratio:r.size/n,untagged_ratio:(n-r.size)/n}}groupByContentSimilarity(e,n){return Array.from(n.entries()).filter(([r,i])=>i.size>=2).map(([r,i])=>({keyword:r,note_count:i.size,notes:Array.from(i).slice(0,5)}))}identifyLearningSessions(e){return e.filter(n=>n.note_count>=3).map(n=>({date:n.date,intensity:n.note_count>10?"high":n.note_count>5?"medium":"low",note_count:n.note_count}))}calculateStudyFrequency(e){let n=e.map(s=>new Date(s.date)),r=Math.max(...n.map(s=>s.getTime()))-Math.min(...n.map(s=>s.getTime())),i=e.length/(r/(1e3*60*60*24)||1);return{sessions_per_day:Math.round(i*100)/100,total_sessions:e.length,date_range_days:Math.round(r/(1e3*60*60*24))}}};var te=class{constructor(){this.tools=new Map;this.ankiClient=new S,this.registerTools()}register(t){this.tools.set(t.name,t)}registerTools(){this.register(new q(this.ankiClient)),this.register(new M(this.ankiClient)),this.register(new A(this.ankiClient)),this.register(new D(this.ankiClient)),this.register(new $(this.ankiClient)),this.register(new z(this.ankiClient)),this.register(new O(this.ankiClient)),this.register(new F(this.ankiClient)),this.register(new j(this.ankiClient)),this.register(new L(this.ankiClient)),this.register(new W(this.ankiClient)),this.register(new H(this.ankiClient)),this.register(new U(this.ankiClient)),this.register(new B(this.ankiClient)),this.register(new J(this.ankiClient)),this.register(new G(this.ankiClient)),this.register(new K(this.ankiClient)),this.register(new V(this.ankiClient)),this.register(new Q(this.ankiClient)),this.register(new Y(this.ankiClient)),this.register(new X(this.ankiClient)),this.register(new Z(this.ankiClient))}async getToolSchema(){let t=Array.from(this.tools.values()).map(n=>({name:n.name,description:n.description,inputSchema:n.inputSchema})),e=await this.ankiClient.getModelNames();for(let n of e){let r=new _(this.ankiClient,n);t.push({name:r.name,description:r.description,inputSchema:r.inputSchema})}return{tools:t}}async executeTool(t,e){await this.ankiClient.checkConnection();try{let n=this.tools.get(t);if(!n){let r=t.match(/^create_(.+)_note$/);if(r){let i=r[1].replace(/_/g," ");n=new _(this.ankiClient,i)}}if(n)return await n.execute(e);throw new E.McpError(E.ErrorCode.MethodNotFound,`Unknown tool: ${t}`)}catch(n){if(n instanceof E.McpError)throw n;return{content:[{type:"text",text:`Error: ${n instanceof Error?n.message:String(n)}`}],isError:!0}}}};var re=require("@modelcontextprotocol/sdk/types.js"),ne=class{constructor(t){this.ankiClient=t}async listPrompts(){return{prompts:[{name:"study-helper",description:"Study Assistant - Assists in analyzing learning progress and providing study recommendations",arguments:[{name:"deck_name",description:"Name of the deck to analyze",required:!1},{name:"analysis_type",description:"Analysis type: overview, progress, recommendations",required:!1}]},{name:"note-creator",description:"Note Creation Wizard - Helps users create structured Anki notes",arguments:[{name:"topic",description:"Learning topic or subject area",required:!0},{name:"note_type",description:"Specified note type, will recommend suitable type if not specified",required:!1},{name:"source_content",description:"Source content or reference materials",required:!1}]},{name:"review-analyzer",description:"Review Analyst - Analyzes review performance and optimizes learning strategies",arguments:[{name:"time_period",description:"Analysis time period: today, week, month",required:!1},{name:"focus_area",description:"Focus area: difficulty (difficult cards), retention (memory retention), efficiency",required:!1}]},{name:"deck-organizer",description:"Deck Organizer Assistant - Helps optimize deck structure and content",arguments:[{name:"deck_name",description:"Name of the deck to organize",required:!0},{name:"organization_goal",description:"Organization goal: structure (structure optimization), content (content cleanup), tags (tag management)",required:!1}]},{name:"content-enhancer",description:"Content Enhancer - Improves the quality and learning effectiveness of existing notes",arguments:[{name:"note_id",description:"ID of the note to enhance",required:!1},{name:"enhancement_type",description:"Enhancement type: clarity, examples, mnemonics (memory techniques), connections",required:!1}]},{name:"learning-planner",description:"Learning Planner - Creates personalized study plans and review schedules",arguments:[{name:"goal",description:"Learning goal description",required:!0},{name:"time_available",description:"Available study time (minutes/day)",required:!1},{name:"difficulty_preference",description:"Difficulty preference: easy, moderate, challenging",required:!1}]},{name:"knowledge-mapper",description:"Knowledge Map Builder - Analyzes and visualizes connections between knowledge points",arguments:[{name:"subject",description:"Subject or topic area",required:!0},{name:"connection_type",description:"Connection type: conceptual, hierarchical, temporal",required:!1}]},{name:"spaced-repetition-optimizer",description:"Spaced Repetition Optimizer - Optimizes review intervals and learning efficiency",arguments:[{name:"performance_data",description:"Recent learning performance data or description",required:!1},{name:"optimization_focus",description:"Optimization focus: retention (memory retention), speed (learning speed), difficulty (tackling difficult points)",required:!1}]}]}}async getPrompt(t,e){switch(t){case"study-helper":return await this.getStudyHelperPrompt(e);case"note-creator":return await this.getNoteCreatorPrompt(e);case"review-analyzer":return await this.getReviewAnalyzerPrompt(e);case"deck-organizer":return await this.getDeckOrganizerPrompt(e);case"content-enhancer":return await this.getContentEnhancerPrompt(e);case"learning-planner":return await this.getLearningPlannerPrompt(e);case"knowledge-mapper":return await this.getKnowledgeMapperPrompt(e);case"spaced-repetition-optimizer":return await this.getSpacedRepetitionOptimizerPrompt(e);default:throw new re.McpError(re.ErrorCode.MethodNotFound,`Unknown prompt template: ${t}`)}}async getStudyHelperPrompt(t){let e=t==null?void 0:t.deck_name,n=(t==null?void 0:t.analysis_type)||"overview",r="";if(e)try{let s=await this.ankiClient.getDeckStats(e);r=`

Current deck "${e}" data:
${JSON.stringify(s,null,2)}`}catch{r=`

Note: Unable to retrieve data for deck "${e}", the name might be incorrect or the deck does not exist.`}return{prompt:{name:"study-helper",description:"\u5B66\u4E60\u52A9\u624B - \u5206\u6790\u5B66\u4E60\u8FDB\u5EA6\u5E76\u63D0\u4F9B\u5EFA\u8BAE",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684 Anki \u5B66\u4E60\u52A9\u624B\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5E2E\u52A9\u7528\u6237\u5206\u6790\u4ED6\u4EEC\u7684\u5B66\u4E60\u8FDB\u5EA6\uFF0C\u8BC6\u522B\u5B66\u4E60\u6A21\u5F0F\uFF0C\u5E76\u63D0\u4F9B\u4E2A\u6027\u5316\u7684\u5B66\u4E60\u5EFA\u8BAE\u3002

\u4F60\u53EF\u4EE5\u8BBF\u95EE\u7528\u6237\u7684 Anki \u6570\u636E\uFF0C\u5305\u62EC\uFF1A
- \u5361\u7247\u7EC4\u7EDF\u8BA1\u4FE1\u606F
- \u5B66\u4E60\u8FDB\u5EA6\u6570\u636E
- \u590D\u4E60\u8868\u73B0
- \u5361\u7247\u5206\u5E03\u60C5\u51B5

\u5206\u6790\u91CD\u70B9\uFF1A${n==="overview"?"\u6574\u4F53\u5B66\u4E60\u6982\u51B5":n==="progress"?"\u5B66\u4E60\u8FDB\u5EA6\u8BE6\u60C5":"\u5177\u4F53\u5B66\u4E60\u5EFA\u8BAE"}

\u8BF7\u6839\u636E\u7528\u6237\u7684\u6570\u636E\u63D0\u4F9B\uFF1A
1. \u5B66\u4E60\u73B0\u72B6\u5206\u6790
2. \u5F3A\u9879\u548C\u9700\u8981\u6539\u8FDB\u7684\u9886\u57DF
3. \u5177\u4F53\u7684\u5B66\u4E60\u5EFA\u8BAE
4. \u4F18\u5316\u5EFA\u8BAE\u548C\u884C\u52A8\u8BA1\u5212

\u4F7F\u7528\u6E29\u6696\u3001\u9F13\u52B1\u7684\u8BED\u8C03\uFF0C\u63D0\u4F9B\u5B9E\u7528\u4E14\u53EF\u64CD\u4F5C\u7684\u5EFA\u8BAE\u3002${r}`}}]}}}async getNoteCreatorPrompt(t){let e=(t==null?void 0:t.topic)||"[Please specify topic]",n=t==null?void 0:t.note_type,r=(t==null?void 0:t.source_content)||"",i="";try{i=`

Available note types: ${(await this.ankiClient.getModelNames()).join(", ")}`}catch{i=`

Note: Unable to retrieve note type list.`}return{prompt:{name:"note-creator",description:"\u7B14\u8BB0\u521B\u5EFA\u5411\u5BFC - \u521B\u5EFA\u7ED3\u6784\u5316\u7684 Anki \u7B14\u8BB0",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684 Anki \u7B14\u8BB0\u521B\u5EFA\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5E2E\u52A9\u7528\u6237\u521B\u5EFA\u9AD8\u8D28\u91CF\u3001\u7ED3\u6784\u5316\u7684\u5B66\u4E60\u7B14\u8BB0\u3002

\u5F53\u524D\u521B\u5EFA\u4EFB\u52A1\uFF1A
\u4E3B\u9898\uFF1A${e}
${n?`\u6307\u5B9A\u7B14\u8BB0\u7C7B\u578B\uFF1A${n}`:""}
${r?`\u53C2\u8003\u5185\u5BB9\uFF1A
${r}`:""}

\u8BF7\u5E2E\u52A9\u7528\u6237\uFF1A
1. \u5206\u6790\u4E3B\u9898\u5185\u5BB9\uFF0C\u786E\u5B9A\u5173\u952E\u77E5\u8BC6\u70B9
2. \u63A8\u8350\u6700\u9002\u5408\u7684\u7B14\u8BB0\u7C7B\u578B\uFF08\u5982\u679C\u672A\u6307\u5B9A\uFF09
3. \u8BBE\u8BA1\u5361\u7247\u6B63\u9762\u95EE\u9898\uFF08\u7B80\u6D01\u3001\u660E\u786E\u3001\u5177\u6709\u6D4B\u8BD5\u6027\uFF09
4. \u7F16\u5199\u5361\u7247\u80CC\u9762\u7B54\u6848\uFF08\u5B8C\u6574\u3001\u51C6\u786E\u3001\u5305\u542B\u5173\u952E\u7EC6\u8282\uFF09
5. \u5EFA\u8BAE\u76F8\u5173\u7684\u6807\u7B7E
6. \u63D0\u4F9B\u8BB0\u5FC6\u6280\u5DE7\u6216\u52A9\u8BB0\u65B9\u6CD5

\u7B14\u8BB0\u8BBE\u8BA1\u539F\u5219\uFF1A
- \u539F\u5B50\u5316\uFF1A\u6BCF\u5F20\u5361\u7247\u53EA\u5305\u542B\u4E00\u4E2A\u77E5\u8BC6\u70B9
- \u6E05\u6670\u6027\uFF1A\u95EE\u9898\u548C\u7B54\u6848\u90FD\u8981\u6E05\u695A\u660E\u4E86
- \u53EF\u6D4B\u8BD5\u6027\uFF1A\u95EE\u9898\u8981\u80FD\u51C6\u786E\u6D4B\u8BD5\u77E5\u8BC6\u638C\u63E1\u7A0B\u5EA6
- \u5173\u8054\u6027\uFF1A\u4E0E\u76F8\u5173\u77E5\u8BC6\u70B9\u5EFA\u7ACB\u8FDE\u63A5

${i}

\u8BF7\u4E3A\u6B64\u4E3B\u9898\u521B\u5EFA\u9AD8\u8D28\u91CF\u7684 Anki \u7B14\u8BB0\u3002`}}]}}}async getReviewAnalyzerPrompt(t){let e=(t==null?void 0:t.time_period)||"recent",n=(t==null?void 0:t.focus_area)||"overall";return{prompt:{name:"review-analyzer",description:"\u590D\u4E60\u5206\u6790\u5E08 - \u5206\u6790\u590D\u4E60\u8868\u73B0\u5E76\u4F18\u5316\u5B66\u4E60\u7B56\u7565",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684 Anki \u590D\u4E60\u5206\u6790\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5206\u6790\u7528\u6237\u7684\u590D\u4E60\u8868\u73B0\uFF0C\u8BC6\u522B\u5B66\u4E60\u6A21\u5F0F\uFF0C\u5E76\u63D0\u4F9B\u4F18\u5316\u5EFA\u8BAE\u3002

\u5206\u6790\u65F6\u95F4\u6BB5\uFF1A${e}
\u5173\u6CE8\u9886\u57DF\uFF1A${n}

\u8BF7\u4ECE\u4EE5\u4E0B\u89D2\u5EA6\u8FDB\u884C\u5206\u6790\uFF1A

1. **\u590D\u4E60\u8868\u73B0\u5206\u6790**
   - \u7B54\u5BF9\u7387\u8D8B\u52BF
   - \u56F0\u96BE\u5361\u7247\u8BC6\u522B
   - \u5B66\u4E60\u6548\u7387\u8BC4\u4F30

2. **\u5B66\u4E60\u6A21\u5F0F\u8BC6\u522B**
   - \u5B66\u4E60\u65F6\u95F4\u5206\u5E03
   - \u9057\u5FD8\u66F2\u7EBF\u7279\u5F81
   - \u590D\u4E60\u9891\u7387\u6A21\u5F0F

3. **\u95EE\u9898\u8BCA\u65AD**
   - \u77E5\u8BC6\u8584\u5F31\u73AF\u8282
   - \u5B66\u4E60\u65B9\u6CD5\u95EE\u9898
   - \u65F6\u95F4\u7BA1\u7406\u95EE\u9898

4. **\u4F18\u5316\u5EFA\u8BAE**
   - \u590D\u4E60\u7B56\u7565\u8C03\u6574
   - \u5B66\u4E60\u8BA1\u5212\u4F18\u5316
   - \u5177\u4F53\u6539\u8FDB\u63AA\u65BD

\u8BF7\u4F7F\u7528\u6570\u636E\u9A71\u52A8\u7684\u65B9\u6CD5\uFF0C\u63D0\u4F9B\u5177\u4F53\u3001\u53EF\u884C\u7684\u6539\u8FDB\u5EFA\u8BAE\u3002\u5173\u6CE8\u957F\u671F\u5B66\u4E60\u6548\u679C\u7684\u63D0\u5347\u3002`}}]}}}async getDeckOrganizerPrompt(t){let e=(t==null?void 0:t.deck_name)||"[\u8BF7\u6307\u5B9A\u5361\u7247\u7EC4\u540D\u79F0]",n=(t==null?void 0:t.organization_goal)||"comprehensive",r="";if(e!=="[\u8BF7\u6307\u5B9A\u5361\u7247\u7EC4\u540D\u79F0]")try{let s=await this.ankiClient.findNotes(`deck:"${e}"`),o=await this.ankiClient.getDeckStats(e);r=`

\u5361\u7247\u7EC4 "${e}" \u73B0\u72B6\uFF1A
- \u7B14\u8BB0\u6570\u91CF\uFF1A${s.length}
- \u7EDF\u8BA1\u4FE1\u606F\uFF1A${JSON.stringify(o,null,2)}`}catch{r=`

\u6CE8\u610F\uFF1A\u65E0\u6CD5\u83B7\u53D6\u5361\u7247\u7EC4 "${e}" \u7684\u6570\u636E\u3002`}return{prompt:{name:"deck-organizer",description:"\u5361\u7247\u7EC4\u6574\u7406\u52A9\u624B - \u4F18\u5316\u5361\u7247\u7EC4\u7ED3\u6784\u548C\u5185\u5BB9",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684 Anki \u5361\u7247\u7EC4\u6574\u7406\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5E2E\u52A9\u7528\u6237\u4F18\u5316\u5361\u7247\u7EC4\u7684\u7ED3\u6784\u3001\u5185\u5BB9\u548C\u7BA1\u7406\u65B9\u5F0F\u3002

\u6574\u7406\u76EE\u6807\uFF1A${n}
\u76EE\u6807\u5361\u7247\u7EC4\uFF1A${e}

\u8BF7\u63D0\u4F9B\u4EE5\u4E0B\u65B9\u9762\u7684\u6574\u7406\u5EFA\u8BAE\uFF1A

1. **\u7ED3\u6784\u4F18\u5316**
   - \u5361\u7247\u7EC4\u5C42\u6B21\u7ED3\u6784
   - \u5B50\u5361\u7247\u7EC4\u5212\u5206\u5EFA\u8BAE
   - \u5185\u5BB9\u5206\u7C7B\u65B9\u6848

2. **\u5185\u5BB9\u8D28\u91CF\u6539\u8FDB**
   - \u91CD\u590D\u5185\u5BB9\u8BC6\u522B
   - \u4F4E\u8D28\u91CF\u5361\u7247\u7B5B\u9009
   - \u5185\u5BB9\u4E00\u81F4\u6027\u68C0\u67E5

3. **\u6807\u7B7E\u7BA1\u7406**
   - \u6807\u7B7E\u4F53\u7CFB\u8BBE\u8BA1
   - \u6807\u7B7E\u6807\u51C6\u5316\u5EFA\u8BAE
   - \u6807\u7B7E\u4F7F\u7528\u7B56\u7565

4. **\u5B66\u4E60\u6548\u7387\u4F18\u5316**
   - \u5361\u7247\u96BE\u5EA6\u5206\u5C42
   - \u590D\u4E60\u4F18\u5148\u7EA7\u8BBE\u7F6E
   - \u5B66\u4E60\u8DEF\u5F84\u89C4\u5212

5. **\u7EF4\u62A4\u7B56\u7565**
   - \u5B9A\u671F\u7EF4\u62A4\u8BA1\u5212
   - \u8D28\u91CF\u76D1\u63A7\u65B9\u6CD5
   - \u6301\u7EED\u6539\u8FDB\u673A\u5236

\u8BF7\u63D0\u4F9B\u5177\u4F53\u3001\u53EF\u64CD\u4F5C\u7684\u6574\u7406\u65B9\u6848\u548C\u5B9E\u65BD\u6B65\u9AA4\u3002${r}`}}]}}}async getContentEnhancerPrompt(t){let e=t==null?void 0:t.note_id,n=(t==null?void 0:t.enhancement_type)||"comprehensive",r="";if(e)try{let s=await this.ankiClient.notesInfo([parseInt(e)]);s.length>0&&(r=`

\u5F53\u524D\u7B14\u8BB0\u5185\u5BB9\uFF1A
${JSON.stringify(s[0],null,2)}`)}catch{r=`

\u6CE8\u610F\uFF1A\u65E0\u6CD5\u83B7\u53D6\u7B14\u8BB0 ID ${e} \u7684\u6570\u636E\u3002`}return{prompt:{name:"content-enhancer",description:"\u5185\u5BB9\u589E\u5F3A\u5668 - \u6539\u8FDB\u7B14\u8BB0\u8D28\u91CF\u548C\u5B66\u4E60\u6548\u679C",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684 Anki \u5185\u5BB9\u589E\u5F3A\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u6539\u8FDB\u73B0\u6709\u7B14\u8BB0\u7684\u8D28\u91CF\uFF0C\u63D0\u9AD8\u5B66\u4E60\u6548\u679C\u548C\u8BB0\u5FC6\u4FDD\u6301\u7387\u3002

\u589E\u5F3A\u91CD\u70B9\uFF1A${n}
${e?`\u76EE\u6807\u7B14\u8BB0 ID\uFF1A${e}`:""}

\u8BF7\u4ECE\u4EE5\u4E0B\u7EF4\u5EA6\u63D0\u4F9B\u589E\u5F3A\u5EFA\u8BAE\uFF1A

1. **\u5185\u5BB9\u6E05\u6670\u5EA6\u63D0\u5347**
   - \u8BED\u8A00\u8868\u8FBE\u4F18\u5316
   - \u903B\u8F91\u7ED3\u6784\u6539\u8FDB
   - \u5173\u952E\u4FE1\u606F\u7A81\u51FA

2. **\u5B66\u4E60\u6548\u679C\u589E\u5F3A**
   - \u6DFB\u52A0\u5B9E\u4F8B\u548C\u6848\u4F8B
   - \u63D0\u4F9B\u8BB0\u5FC6\u6280\u5DE7
   - \u589E\u52A0\u89C6\u89C9\u5316\u5143\u7D20

3. **\u77E5\u8BC6\u5173\u8054\u5EFA\u8BBE**
   - \u4E0E\u76F8\u5173\u6982\u5FF5\u7684\u8FDE\u63A5
   - \u4E0A\u4E0B\u6587\u4FE1\u606F\u8865\u5145
   - \u4EA4\u53C9\u5F15\u7528\u5EFA\u8BAE

4. **\u6D4B\u8BD5\u6548\u679C\u6539\u8FDB**
   - \u95EE\u9898\u8BBE\u8BA1\u4F18\u5316
   - \u7B54\u6848\u5B8C\u6574\u6027\u68C0\u67E5
   - \u96BE\u5EA6\u7EA7\u522B\u8C03\u6574

5. **\u4E2A\u6027\u5316\u5B9A\u5236**
   - \u6839\u636E\u5B66\u4E60\u76EE\u6807\u8C03\u6574
   - \u8003\u8651\u77E5\u8BC6\u80CC\u666F
   - \u9002\u5E94\u5B66\u4E60\u98CE\u683C

\u8BF7\u63D0\u4F9B\u5177\u4F53\u7684\u6539\u8FDB\u65B9\u6848\u548C\u4FEE\u6539\u5EFA\u8BAE\u3002${r}`}}]}}}async getLearningPlannerPrompt(t){let e=(t==null?void 0:t.goal)||"[\u8BF7\u63CF\u8FF0\u5B66\u4E60\u76EE\u6807]",n=(t==null?void 0:t.time_available)||"\u672A\u6307\u5B9A",r=(t==null?void 0:t.difficulty_preference)||"moderate",i="";try{i=`

\u5F53\u524D\u5361\u7247\u7EC4\uFF1A${(await this.ankiClient.getDeckNames()).join(", ")}`}catch{i=`

\u6CE8\u610F\uFF1A\u65E0\u6CD5\u83B7\u53D6\u5F53\u524D\u5B66\u4E60\u72B6\u6001\u3002`}return{prompt:{name:"learning-planner",description:"\u5B66\u4E60\u8BA1\u5212\u5E08 - \u5236\u5B9A\u4E2A\u6027\u5316\u5B66\u4E60\u8BA1\u5212",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684\u4E2A\u6027\u5316\u5B66\u4E60\u8BA1\u5212\u5E08\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u6839\u636E\u7528\u6237\u7684\u76EE\u6807\u3001\u65F6\u95F4\u5B89\u6392\u548C\u504F\u597D\uFF0C\u5236\u5B9A\u79D1\u5B66\u6709\u6548\u7684 Anki \u5B66\u4E60\u8BA1\u5212\u3002

\u5B66\u4E60\u76EE\u6807\uFF1A${e}
\u53EF\u7528\u65F6\u95F4\uFF1A${n} \u5206\u949F/\u5929
\u96BE\u5EA6\u504F\u597D\uFF1A${r}

\u8BF7\u5236\u5B9A\u5305\u542B\u4EE5\u4E0B\u8981\u7D20\u7684\u5B66\u4E60\u8BA1\u5212\uFF1A

1. **\u76EE\u6807\u5206\u89E3**
   - \u957F\u671F\u76EE\u6807\u62C6\u5206
   - \u9636\u6BB5\u6027\u91CC\u7A0B\u7891
   - \u53EF\u91CF\u5316\u6307\u6807

2. **\u65F6\u95F4\u89C4\u5212**
   - \u65E5\u5E38\u5B66\u4E60\u5B89\u6392
   - \u590D\u4E60\u65F6\u95F4\u5206\u914D
   - \u8FDB\u5EA6\u68C0\u67E5\u8282\u70B9

3. **\u5185\u5BB9\u7EC4\u7EC7**
   - \u5B66\u4E60\u5E8F\u5217\u8BBE\u8BA1
   - \u77E5\u8BC6\u6A21\u5757\u5212\u5206
   - \u96BE\u5EA6\u9012\u8FDB\u5B89\u6392

4. **\u590D\u4E60\u7B56\u7565**
   - \u95F4\u9694\u91CD\u590D\u8BA1\u5212
   - \u56F0\u96BE\u5185\u5BB9\u5904\u7406
   - \u5DE9\u56FA\u590D\u4E60\u5B89\u6392

5. **\u76D1\u63A7\u8C03\u6574**
   - \u8FDB\u5EA6\u8DDF\u8E2A\u65B9\u6CD5
   - \u6548\u679C\u8BC4\u4F30\u6807\u51C6
   - \u8BA1\u5212\u8C03\u6574\u673A\u5236

6. **\u52A8\u673A\u7EF4\u6301**
   - \u6210\u5C31\u611F\u57F9\u517B
   - \u6311\u6218\u6027\u5E73\u8861
   - \u5956\u52B1\u673A\u5236\u8BBE\u8BA1

\u8BF7\u63D0\u4F9B\u8BE6\u7EC6\u3001\u53EF\u6267\u884C\u7684\u5B66\u4E60\u8BA1\u5212\uFF0C\u5305\u62EC\u5177\u4F53\u7684\u65F6\u95F4\u5B89\u6392\u548C\u64CD\u4F5C\u6B65\u9AA4\u3002${i}`}}]}}}async getKnowledgeMapperPrompt(t){let e=(t==null?void 0:t.subject)||"[\u8BF7\u6307\u5B9A\u5B66\u79D1\u9886\u57DF]",n=(t==null?void 0:t.connection_type)||"comprehensive";return{prompt:{name:"knowledge-mapper",description:"\u77E5\u8BC6\u56FE\u8C31\u6784\u5EFA\u5668 - \u5206\u6790\u77E5\u8BC6\u5173\u8054\u5E76\u4F18\u5316\u5B66\u4E60\u7ED3\u6784",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684\u77E5\u8BC6\u56FE\u8C31\u6784\u5EFA\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5206\u6790\u548C\u53EF\u89C6\u5316\u77E5\u8BC6\u70B9\u4E4B\u95F4\u7684\u5173\u8054\uFF0C\u5E2E\u52A9\u7528\u6237\u5EFA\u7ACB\u7CFB\u7EDF\u5316\u7684\u77E5\u8BC6\u7ED3\u6784\u3002

\u5206\u6790\u9886\u57DF\uFF1A${e}
\u5173\u8054\u7C7B\u578B\uFF1A${n}

\u8BF7\u4ECE\u4EE5\u4E0B\u89D2\u5EA6\u6784\u5EFA\u77E5\u8BC6\u56FE\u8C31\uFF1A

1. **\u6838\u5FC3\u6982\u5FF5\u8BC6\u522B**
   - \u57FA\u7840\u6982\u5FF5\u63D0\u53D6
   - \u91CD\u8981\u6027\u6743\u91CD\u5206\u6790
   - \u6982\u5FF5\u5C42\u6B21\u5212\u5206

2. **\u5173\u8054\u5173\u7CFB\u5206\u6790**
   - \u56E0\u679C\u5173\u7CFB
   - \u5305\u542B\u5173\u7CFB
   - \u5BF9\u6BD4\u5173\u7CFB
   - \u4F9D\u8D56\u5173\u7CFB

3. **\u77E5\u8BC6\u8DEF\u5F84\u89C4\u5212**
   - \u5B66\u4E60\u5148\u540E\u987A\u5E8F
   - \u77E5\u8BC6\u70B9\u4F9D\u8D56\u94FE
   - \u6700\u4F18\u5B66\u4E60\u8DEF\u5F84

4. **gap \u5206\u6790**
   - \u77E5\u8BC6\u7A7A\u767D\u8BC6\u522B
   - \u8584\u5F31\u73AF\u8282\u8BCA\u65AD
   - \u8865\u5F3A\u5EFA\u8BAE

5. **\u5E94\u7528\u573A\u666F\u6620\u5C04**
   - \u5B9E\u9645\u5E94\u7528\u8FDE\u63A5
   - \u8DE8\u9886\u57DF\u5173\u8054
   - \u7EFC\u5408\u8FD0\u7528\u6848\u4F8B

6. **Anki \u7EC4\u7EC7\u5EFA\u8BAE**
   - \u5361\u7247\u7EC4\u7ED3\u6784\u8BBE\u8BA1
   - \u6807\u7B7E\u4F53\u7CFB\u89C4\u5212
   - \u590D\u4E60\u7B56\u7565\u5339\u914D

\u8BF7\u63D0\u4F9B\u7CFB\u7EDF\u5316\u7684\u77E5\u8BC6\u56FE\u8C31\u548C\u5177\u4F53\u7684 Anki \u7EC4\u7EC7\u65B9\u6848\u3002`}}]}}}async getSpacedRepetitionOptimizerPrompt(t){let e=(t==null?void 0:t.performance_data)||"\u8BF7\u63D0\u4F9B\u8FD1\u671F\u5B66\u4E60\u8868\u73B0\u6570\u636E",n=(t==null?void 0:t.optimization_focus)||"comprehensive";return{prompt:{name:"spaced-repetition-optimizer",description:"\u95F4\u9694\u91CD\u590D\u4F18\u5316\u5668 - \u4F18\u5316\u590D\u4E60\u7B56\u7565\u548C\u5B66\u4E60\u6548\u7387",messages:[{role:"user",content:{type:"text",text:`\u4F60\u662F\u4E00\u4E2A\u4E13\u4E1A\u7684\u95F4\u9694\u91CD\u590D\u4F18\u5316\u4E13\u5BB6\u3002\u4F60\u7684\u4EFB\u52A1\u662F\u5206\u6790\u5B66\u4E60\u8868\u73B0\u6570\u636E\uFF0C\u4F18\u5316\u590D\u4E60\u95F4\u9694\u548C\u5B66\u4E60\u7B56\u7565\uFF0C\u6700\u5927\u5316\u5B66\u4E60\u6548\u7387\u548C\u8BB0\u5FC6\u4FDD\u6301\u7387\u3002

\u5B66\u4E60\u8868\u73B0\u6570\u636E\uFF1A${e}
\u4F18\u5316\u91CD\u70B9\uFF1A${n}

\u8BF7\u63D0\u4F9B\u4EE5\u4E0B\u65B9\u9762\u7684\u4F18\u5316\u5EFA\u8BAE\uFF1A

1. **\u590D\u4E60\u95F4\u9694\u4F18\u5316**
   - \u4E2A\u6027\u5316\u95F4\u9694\u8C03\u6574
   - \u9057\u5FD8\u66F2\u7EBF\u5206\u6790
   - \u6700\u4F18\u590D\u4E60\u65F6\u673A

2. **\u96BE\u5EA6\u7BA1\u7406**
   - \u56F0\u96BE\u5361\u7247\u7B56\u7565
   - \u7B80\u5355\u5361\u7247\u5904\u7406
   - \u96BE\u5EA6\u68AF\u5EA6\u8BBE\u8BA1

3. **\u5B66\u4E60\u8D1F\u8377\u5E73\u8861**
   - \u65E5\u5E38\u590D\u4E60\u91CF\u63A7\u5236
   - \u65B0\u5B66\u4E60\u4E0E\u590D\u4E60\u6BD4\u4F8B
   - \u8BA4\u77E5\u8D1F\u8377\u7BA1\u7406

4. **\u8BB0\u5FC6\u5F3A\u5316\u6280\u672F**
   - \u591A\u91CD\u7F16\u7801\u7B56\u7565
   - \u8054\u60F3\u8BB0\u5FC6\u65B9\u6CD5
   - \u60C5\u5883\u4F9D\u8D56\u5B66\u4E60

5. **\u6548\u7387\u76D1\u63A7\u6307\u6807**
   - \u5173\u952E\u7EE9\u6548\u6307\u6807
   - \u6539\u8FDB\u6548\u679C\u6D4B\u91CF
   - \u8C03\u6574\u89E6\u53D1\u6761\u4EF6

6. **\u4E2A\u6027\u5316\u8C03\u4F18**
   - \u5B66\u4E60\u98CE\u683C\u9002\u914D
   - \u65F6\u95F4\u504F\u597D\u8003\u8651
   - \u8BA4\u77E5\u7279\u70B9\u5339\u914D

\u8BF7\u63D0\u4F9B\u79D1\u5B66\u3001\u53EF\u64CD\u4F5C\u7684\u4F18\u5316\u65B9\u6848\uFF0C\u5305\u62EC\u5177\u4F53\u7684\u53C2\u6570\u8C03\u6574\u5EFA\u8BAE\u3002`}}]}}}};var me="0.2.0";var ie=class{constructor(){this.server=new ue.Server({name:"anki-connect-server",version:me},{capabilities:{tools:{},resources:{},prompts:{}}}),this.ankiClient=new S,this.resourceHandler=new T(this.ankiClient),this.toolHandler=new te,this.promptHandler=new ne(this.ankiClient),this.setupHandlers(),this.server.onerror=t=>console.error("[MCP Error]",t),process.on("SIGINT",async()=>{await this.server.close(),process.exit(0)})}setupHandlers(){this.server.setRequestHandler(f.ListResourcesRequestSchema,async()=>(await this.checkConnection(),this.resourceHandler.listResources())),this.server.setRequestHandler(f.ListResourceTemplatesRequestSchema,async()=>(await this.checkConnection(),this.resourceHandler.listResourceTemplates())),this.server.setRequestHandler(f.ReadResourceRequestSchema,async t=>(await this.checkConnection(),this.resourceHandler.readResource(t.params.uri))),this.server.setRequestHandler(f.ListToolsRequestSchema,async()=>(await this.checkConnection(),this.toolHandler.getToolSchema())),this.server.setRequestHandler(f.CallToolRequestSchema,async t=>(await this.checkConnection(),this.toolHandler.executeTool(t.params.name,t.params.arguments))),this.server.setRequestHandler(f.ListPromptsRequestSchema,async()=>(await this.checkConnection(),this.promptHandler.listPrompts())),this.server.setRequestHandler(f.GetPromptRequestSchema,async t=>(await this.checkConnection(),this.promptHandler.getPrompt(t.params.name,t.params.arguments)))}async checkConnection(){try{await this.ankiClient.checkConnection()}catch{throw new f.McpError(f.ErrorCode.InternalError,"Failed to connect to Anki. Please make sure Anki is running and the AnkiConnect plugin is enabled.")}}async run(){let t=new he.StdioServerTransport;await this.server.connect(t),console.error("Anki MCP server running on stdio")}};async function fe(){try{await new ie().run()}catch(d){console.error("Failed to start Anki MCP Server:",d),process.exit(1)}}fe().catch(console.error);
